zoukankan      html  css  js  c++  java
  • HDU 1069 Monkey and Banana(二维偏序LIS的应用)

    ---恢复内容开始---

    Monkey and Banana

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
    Total Submission(s): 13003    Accepted Submission(s): 6843

    Problem Description
    A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

    The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height. 

    They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked. 

    Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.
     
    Input
    The input file will contain one or more test cases. The first line of each test case contains an integer n,
    representing the number of different blocks in the following data set. The maximum value for n is 30.
    Each of the next n lines contains three integers representing the values xi, yi and zi.
    Input is terminated by a value of zero (0) for n.
     
    Output
    For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".
     
    Sample Input
    1
    10 20 30
    2
    6 8 10
    5 5 5
    7
    1 1 1
    2 2 2
    3 3 3
    4 4 4
    5 5 5
    6 6 6
    7 7 7
    5
    31 41 59
    26 53 5
    8 97 93
    23 84 62
    64 33 83 27
    0
     
    Sample Output
    Case 1: maximum height = 40
    Case 2: maximum height = 21
    Case 3: maximum height = 28
    Case 4: maximum height = 342
     

    题目链接:HDU 1069

    题意:给出n种块的尺寸,用坐标x、y、z表示,当某一个块的两个比下面的块中某个两个坐标小的时候就可以把这个块叠上去,可以把块旋转一下使得三个坐标互相转变……

    块的数量是无限的其实是吓唬人的,由于是要严格上升,显然三个已经把所有情况考虑了,四个肯定会跟某一种重复,然后每一个块都假设有三个,用O(n2)的方法求一种可以说是带权LIS的东西就行了

    代码:

    #include <stdio.h>
    #include <bits/stdc++.h>
    using namespace std;
    #define INF 0x3f3f3f3f
    #define CLR(arr,val) memset(arr,val,sizeof(arr))
    #define LC(x) (x<<1)
    #define RC(x) ((x<<1)+1)
    #define MID(x,y) ((x+y)>>1)
    typedef pair<int,int> pii;
    typedef long long LL;
    const double PI=acos(-1.0);
    const int N=190;
    struct info
    {
        int x;
        int y;
        int z;
        bool operator<(const info &t)const
        {
            if(x!=t.x)
                return x<t.x;
            return y<t.y;
        }
        info(int xx,int yy,int zz):x(xx),y(yy),z(zz){}
        info(){}
    };
    vector<info>arr;
    int dp[N];
    int main(void)
    {
        int n,i,j,x,y,z;
        int q=1;
        while (~scanf("%d",&n)&&n)
        {
            CLR(dp,0);
            arr.clear();
            for (i=0; i<n; ++i)
            {
                scanf("%d%d%d",&x,&y,&z);
                arr.push_back(info(x,y,z));
                arr.push_back(info(x,z,y));
    
                arr.push_back(info(y,x,z));
                arr.push_back(info(y,z,x));
    
                arr.push_back(info(z,x,y));
                arr.push_back(info(z,y,x));
            }
            sort(arr.begin(),arr.end());
            int SZ=arr.size();
            for (i=0; i<SZ; ++i)
            {
                int pre_max=0;
                for (j=0; j<i; ++j)
                {
                    if(arr[j].x<arr[i].x&&arr[j].y<arr[i].y&&dp[j]>pre_max)
                        pre_max=dp[j];
                }
                dp[i]=pre_max+arr[i].z;
            }
            printf("Case %d: maximum height = %d
    ",q++,*max_element(dp,dp+SZ));//n^2算法这里就要取max,之前搞混了直接输出最后一个导致WA
        }
        return 0;
    }
  • 相关阅读:
    在阿里云“专有网络”网络类型中配置vsftpd
    Ubuntu 16.04下开启Mysql 3306端口远程访问
    .net core 2.0 报错:error NU1102: Unable to find package ...
    .NET Core Runtime ARM32 builds now available
    .NET Core on Raspberry Pi
    .NET Core 跨平台发布(dotnet publish)
    使用vscode开发调试.net core应用程序并部署到Linux跨平台
    docker容器镜像删除
    使用阿里docker镜像加速器加速
    树莓派3b基于UbuntuMate下载中文输入法
  • 原文地址:https://www.cnblogs.com/Blackops/p/5930755.html
Copyright © 2011-2022 走看看